#include "cglib/glut_window.h"

GlutWindow *GlutWindow::GlutWindow_instance = NULL;

void GlutWindow::StaticDisplayFunc()
{
	GlutWindow_instance->DisplayFunc();
} 

void GlutWindow::StaticReshapeFunc(int width, int height)
{
	GlutWindow_instance->ReshapeFunc(width, height);
}

void GlutWindow::StaticIdleFunc()
{
	GlutWindow_instance->IdleFunc();
}

void GlutWindow::StaticMouseFunc(int button, int state, int x, int y)
{
	GlutWindow_instance->MouseFunc(button, state, x, y);
}

void GlutWindow::StaticMotionFunc(int x, int y)
{
	GlutWindow_instance->MotionFunc(x, y);
}

void GlutWindow::StaticKeyboardFunc(unsigned char key, int x, int y)
{
	GlutWindow_instance->KeyboardFunc(key, x, y);
}

void GlutWindow::StaticSpecialFunc(int key, int x, int y)
{
	GlutWindow_instance->SpecialFunc(key, x, y);
}

void GlutWindow::DisplayFunc()
{
	Draw();
	glutSwapBuffers();
}

void GlutWindow::IdleFunc()
{
}

void GlutWindow::KeyboardFunc(unsigned char key, int x, int y)
{
	NormalKey input = NormalKey(key, glutGetModifiers());		
	if (normalKeyHandlers.find(input) != normalKeyHandlers.end())	
		normalKeyHandlers[input](key, x, y);
}

void GlutWindow::SpecialFunc(int key, int x ,int y)
{
	SpecialKey input = SpecialKey(key, glutGetModifiers());
	if (specialKeyHandlers.find(input) != specialKeyHandlers.end())
		specialKeyHandlers[input](key, x, y);
}

void GlutWindow::ReshapeFunc(int width, int height)
{
	glutPostRedisplay();
}
	
void GlutWindow::MouseFunc(int button, int state, int x, int y)
{
}

void GlutWindow::MotionFunc(int x, int y)
{
}

void GlutWindow::Initialize()
{
}

void GlutWindow::InitDisplay()
{
}

void GlutWindow::Draw()
{
}

void GlutWindow::Run(int *argc, char **argv)
{
	Initialize();

	glutInit(argc, argv);
	glutInitWindowSize(windowWidth, windowHeight);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow(windowTitle.c_str());	

	glutDisplayFunc(StaticDisplayFunc);
	glutReshapeFunc(StaticReshapeFunc);
	glutIdleFunc(StaticIdleFunc);
	glutKeyboardFunc(StaticKeyboardFunc);
	glutSpecialFunc(StaticSpecialFunc);
	glutMouseFunc(StaticMouseFunc);
	glutMotionFunc(StaticMotionFunc);

	InitDisplay();

	glutMainLoop();
}

GlutWindow *GlutWindow::GetGlutWindowInstance()
{
	if (GlutWindow_instance == NULL)
	{
		GlutWindow_instance = new GlutWindow();
	}
	return GlutWindow_instance;
}