#include "cglib/group_node.h"
#include "cglib/visitor.h"

GroupNode::GroupNode() : SceneGraphNode()
{
}

GroupNode::~GroupNode()
{
}

int GroupNode::get_children_count() const
{
	return (int)children.size();
}

SceneGraphNode *GroupNode::get_child(int index)
{
	return children[index].get_pointer();
}

void GroupNode::append_child(SceneGraphNode *child)
{
	Reference<SceneGraphNode> ref(child);
	children.push_back(child);
}

void GroupNode::accept(Visitor *visitor)
{
	visitor->visit_GroupNode(this);
}