#include "cglib/material_list.h"
#include "cglib/visitor.h"

MaterialList::MaterialList()
{
    
}

MaterialList::~MaterialList()
{
        
}

int MaterialList::get_material_count() const
{
    return (int)list.size();        
}

void MaterialList::append_material(Material *material)
{
    Reference<Material> ref(material);
    list.push_back(ref);
}

Material *MaterialList::get_material(int index)
{
    return list[index].get_pointer();       
}

void MaterialList::set_material(int index, Material *material)
{
    Reference<Material> ref(material);
    list[index] = ref;
}

void MaterialList::accept(Visitor *visitor)
{
    visitor->visit_MaterialList(this);
}