#include "cglib/mesh_node.h"
#include "cglib/visitor.h"

MeshNode::MeshNode() : SceneGraphNode()
{
    mesh = NULL;
    material_mapping = NULL;
    material_list = NULL;            
}

MeshNode::~MeshNode()
{
        
}

Mesh *MeshNode::get_mesh()
{
    return mesh.get_pointer();        
}

MeshMaterialMapping *MeshNode::get_material_mapping()
{
    return material_mapping.get_pointer();        
}

MaterialList *MeshNode::get_material_list()
{
    return material_list.get_pointer();        
}

void MeshNode::set_mesh(Mesh *a_mesh)
{
    mesh = a_mesh;
}

void MeshNode::set_material_mapping(MeshMaterialMapping *a_material_mapping)
{
    material_mapping = a_material_mapping;        
}

void MeshNode::set_material_list(MaterialList *a_material_list)
{
    material_list = a_material_list;
}

void MeshNode::accept(Visitor *visitor)
{
    visitor->visit_MeshNode(this);
}