#include "cglib/transform.h"

Transform::Transform()
{
	m = Matrix4x4::identity();
	mi = Matrix4x4::identity();
	mit = Matrix4x4::identity();
}

Transform::Transform(const Matrix4x4 &_m, const Matrix4x4 &_mi)
{
	m = _m;
	mi = _mi;
	mit = transpose(mi);
}

Transform::Transform(const Matrix4x4 &_m, const Matrix4x4 &_mi, const Matrix4x4 &_mit)
{
	m = _m;
	mi = _mi;
	mit = _mit;
}

Transform Transform::operator*(const Transform &other) const
{
	return Transform(m * other.m, mi * other.mi, other.mit * mit);
}

Transform &Transform::operator*=(const Transform &other)
{
	m = m * other.m;
	mi = other.mi * mi;
	mit = mit * other.mit;
	return *this;
}

bool Transform::is_near(const Transform &other, float threshold)
{
	return m.is_near(other.m) && mi.is_near(other.mi) && mit.is_near(other.mit);
}