#include "cglib/transform_node.h"
#include "cglib/visitor.h"

TransformNode::TransformNode() : SceneGraphNode()
{
    child = NULL;
    transform = Transform::identity();        
}

TransformNode::~TransformNode()
{
        
}

Transform TransformNode::get_transform() const
{
	return transform;
}

void TransformNode::set_transform(const Transform &_transform)
{
	transform = _transform;
}

SceneGraphNode *TransformNode::get_child()
{
	return child.get_pointer();
}

void TransformNode::set_child(SceneGraphNode *_child)
{
	Reference<SceneGraphNode> ref(_child);
	child = ref;
}

void TransformNode::accept(Visitor *visitor)
{
    visitor->visit_TransformNode(this);
}