#ifndef _MATERIAL_LIST_H_
#define _MATERIAL_LIST_H_

#include <vector>
#include "cglib/material.h"
#include "cglib/object.h"
#include "cglib/reference.h"

//! Represent a list of material.
class MaterialList : public Object
{
public:
    //! An constructor that does nothing.
    MaterialList ();
    
    //! An destructor that does nothing.
    virtual ~MaterialList ();
    
    //! Return the number of materials in the list.
    int get_material_count() const;

    //! Add a material to the end of the list.
    void append_material(Material * material);
    
    //! Get the material with the given index.
    Material *get_material(int index);
    
    //! Set the material with the given index to the given material.
    void set_material(int index, Material *material);
    
    //! Accept a visitor.
    virtual void accept(Visitor *visitor);

private:
    std::vector< Reference<Material> > list; //! the list
};

#endif /* _MATERIAL_LIST_H_ */
