#ifndef _OBJECT_H_
#define _OBJECT_H_

#include "cglib/reference_counted.h"

class Visitor;

//! Represent a CG data item that are dynamically allocated in the heap and are reference counted.
class Object : public ReferenceCounted
{
public:
    //! A constructor that does nothing.
    Object();
    
    //! A destructor that does nothing.
    virtual ~Object();
    
    //! Accept a visitor.
    virtual void accept(Visitor *visitor) = 0;
};

#endif /* _OBJECT_H_ */
