#ifndef _VISITOR_H_
#define _VISITOR_H_

#include "cglib/object.h"
#include "cglib/mesh.h"
#include "cglib/mesh_material_mapping.h"
#include "cglib/material_list.h"
#include "cglib/phong_material.h"
#include "cglib/textured_phong_material.h"
#include "cglib/texture.h"
#include "cglib/mesh_node.h"
#include "cglib/transform_node.h"
#include "cglib/group_node.h"

//! Represent a visitor.
class Visitor
{
public:
    //! Visit an object whose type is unknown at compile time.
    void visit(Object *object);

	virtual void visit_Mesh(Mesh *mesh);
	virtual void visit_MeshMaterialMapping(MeshMaterialMapping *material_mapping);
	virtual void visit_MaterialList(MaterialList *material_list);
	virtual void visit_PhongMaterial(PhongMaterial *material);
	virtual void visit_TexturedPhongMaterial(TexturedPhongMaterial *material);
	virtual void visit_MeshNode(MeshNode *node);
	virtual void visit_TransformNode(TransformNode *node);
	virtual void visit_GroupNode(GroupNode *node);
	virtual void visit_Texture(Texture *texture);
};

#endif /* _VISITOR_H_ */
