#include <gtest/gtest.h>
#include "cglib/mesh.h"
#include "cglib/reference.h"

TEST(TestMesh, TestIcosahedron)
{
	Reference<Mesh> mesh = new Mesh();

	mesh->append_position(Point3(0.000000f, 0.000000f, 0.000000f));
	mesh->append_position(Point3(0.000000f, -0.525731f, 0.850651f));
	mesh->append_position(Point3(0.850651f, 0.000000f, 0.525731f));
	mesh->append_position(Point3(0.850651f, 0.000000f, -0.525731f));
	mesh->append_position(Point3(-0.850651f, 0.000000f, -0.525731f));
	mesh->append_position(Point3(-0.850651f, 0.000000f, 0.525731f));
	mesh->append_position(Point3(-0.525731f, 0.850651f, 0.000000f));
	mesh->append_position(Point3(0.525731f, 0.850651f, 0.000000f));
	mesh->append_position(Point3(0.525731f, -0.850651f, 0.000000f));
	mesh->append_position(Point3(-0.525731f, -0.850651f, 0.000000f));
	mesh->append_position(Point3(0.000000f, -0.525731f, -0.850651f));
	mesh->append_position(Point3(0.000000f, 0.525731f, -0.850651f));
	mesh->append_position(Point3(0.000000f, 0.525731f, 0.850651f));

	mesh->append_normal(Vector3(0.000000f, 0.000000f, 1.000000f));
	mesh->append_normal(Vector3(0.934172f, 0.356822f, 0.000000f));
	mesh->append_normal(Vector3(0.934172f, -0.356822f, 0.000000f));
	mesh->append_normal(Vector3(-0.934172f, 0.356822f, 0.000000f));
	mesh->append_normal(Vector3(-0.934172f, -0.356822f, -0.000000f));
	mesh->append_normal(Vector3(0.000000f, 0.934172f, 0.356822f));
	mesh->append_normal(Vector3(0.000000f, 0.934172f, -0.356822f));
	mesh->append_normal(Vector3(0.356822f, 0.000000f, -0.934172f));
	mesh->append_normal(Vector3(-0.356822f, -0.000000f, -0.934172f));
	mesh->append_normal(Vector3(-0.000000f, -0.934172f, -0.356822f));
	mesh->append_normal(Vector3(0.000000f, -0.934172f, 0.356822f));
	mesh->append_normal(Vector3(0.356822f, 0.000000f, 0.934172f));
	mesh->append_normal(Vector3(-0.356822f, 0.000000f, 0.934172f));
	mesh->append_normal(Vector3(0.577350f, 0.577350f, -0.577350f));
	mesh->append_normal(Vector3(0.577350f, 0.577350f, 0.577350f));
	mesh->append_normal(Vector3(-0.577350f, 0.577350f, -0.577350f));
	mesh->append_normal(Vector3(-0.577350f, 0.577350f, 0.577350f));
	mesh->append_normal(Vector3(0.577350f, -0.577350f, -0.577350f));
	mesh->append_normal(Vector3(0.577350f, -0.577350f, 0.577350f));
	mesh->append_normal(Vector3(-0.577350f, -0.577350f, -0.577350f));
	mesh->append_normal(Vector3(-0.577350f, -0.577350f, 0.577350f));

	mesh->append_tex_coord(Uv(0.000000f, 0.000000f));

	mesh->append_new_face();
	mesh->append_vertex_to_last_face(2, 1, 0);
	mesh->append_vertex_to_last_face(3, 1, 0);
	mesh->append_vertex_to_last_face(7, 1, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(2, 2, 0);
	mesh->append_vertex_to_last_face(8, 2, 0);
	mesh->append_vertex_to_last_face(3, 2, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(4, 3, 0);
	mesh->append_vertex_to_last_face(5, 3, 0);
	mesh->append_vertex_to_last_face(6, 3, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(5, 4, 0);
	mesh->append_vertex_to_last_face(4, 4, 0);
	mesh->append_vertex_to_last_face(9, 4, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(7, 5, 0);
	mesh->append_vertex_to_last_face(6, 5, 0);
	mesh->append_vertex_to_last_face(12, 5, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(6, 6, 0);
	mesh->append_vertex_to_last_face(7, 6, 0);
	mesh->append_vertex_to_last_face(11, 6, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(10, 7, 0);
	mesh->append_vertex_to_last_face(11, 7, 0);
	mesh->append_vertex_to_last_face(3, 7, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(11, 8, 0);
	mesh->append_vertex_to_last_face(10, 8, 0);
	mesh->append_vertex_to_last_face(4, 8, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(8, 9, 0);
	mesh->append_vertex_to_last_face(9, 9, 0);
	mesh->append_vertex_to_last_face(10, 9, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(9, 10, 0);
	mesh->append_vertex_to_last_face(8, 10, 0);
	mesh->append_vertex_to_last_face(1, 10, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(12, 11, 0);
	mesh->append_vertex_to_last_face(1, 11, 0);
	mesh->append_vertex_to_last_face(2, 11, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(1, 12, 0);
	mesh->append_vertex_to_last_face(12, 12, 0);
	mesh->append_vertex_to_last_face(5, 12, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(7, 13, 0);
	mesh->append_vertex_to_last_face(3, 13, 0);
	mesh->append_vertex_to_last_face(11, 13, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(2, 14, 0);
	mesh->append_vertex_to_last_face(7, 14, 0);
	mesh->append_vertex_to_last_face(12, 14, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(4, 15, 0);
	mesh->append_vertex_to_last_face(6, 15, 0);
	mesh->append_vertex_to_last_face(11, 15, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(6, 16, 0);
	mesh->append_vertex_to_last_face(5, 16, 0);
	mesh->append_vertex_to_last_face(12, 16, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(3, 17, 0);
	mesh->append_vertex_to_last_face(8, 17, 0);
	mesh->append_vertex_to_last_face(10, 17, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(8, 18, 0);
	mesh->append_vertex_to_last_face(2, 18, 0);
	mesh->append_vertex_to_last_face(1, 18, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(4, 19, 0);
	mesh->append_vertex_to_last_face(10, 19, 0);
	mesh->append_vertex_to_last_face(9, 19, 0);
	mesh->append_new_face();
	mesh->append_vertex_to_last_face(5, 20, 0);
	mesh->append_vertex_to_last_face(9, 20, 0);
	mesh->append_vertex_to_last_face(1, 20, 0);

	ASSERT_TRUE(Point3(0.000000f, 0.000000f, 0.000000f).is_near(mesh->get_position(0)));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, 0.850651f).is_near(mesh->get_position(1)));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_position(2)));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_position(3)));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_position(4)));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_position(5)));
	ASSERT_TRUE(Point3(-0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_position(6)));
	ASSERT_TRUE(Point3(0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_position(7)));
	ASSERT_TRUE(Point3(0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_position(8)));
	ASSERT_TRUE(Point3(-0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_position(9)));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, -0.850651f).is_near(mesh->get_position(10)));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, -0.850651f).is_near(mesh->get_position(11)));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, 0.850651f).is_near(mesh->get_position(12)));

	ASSERT_TRUE(Vector3(0.000000f, 0.000000f, 1.000000f).is_near(mesh->get_normal(0)));
	ASSERT_TRUE(Vector3(0.934172f, 0.356822f, 0.000000f).is_near(mesh->get_normal(1)));
	ASSERT_TRUE(Vector3(0.934172f, -0.356822f, 0.000000f).is_near(mesh->get_normal(2)));
	ASSERT_TRUE(Vector3(-0.934172f, 0.356822f, 0.000000f).is_near(mesh->get_normal(3)));
	ASSERT_TRUE(Vector3(-0.934172f, -0.356822f, -0.000000f).is_near(mesh->get_normal(4)));
	ASSERT_TRUE(Vector3(0.000000f, 0.934172f, 0.356822f).is_near(mesh->get_normal(5)));
	ASSERT_TRUE(Vector3(0.000000f, 0.934172f, -0.356822f).is_near(mesh->get_normal(6)));
	ASSERT_TRUE(Vector3(0.356822f, 0.000000f, -0.934172f).is_near(mesh->get_normal(7)));
	ASSERT_TRUE(Vector3(-0.356822f, -0.000000f, -0.934172f).is_near(mesh->get_normal(8)));
	ASSERT_TRUE(Vector3(-0.000000f, -0.934172f, -0.356822f).is_near(mesh->get_normal(9)));
	ASSERT_TRUE(Vector3(0.000000f, -0.934172f, 0.356822f).is_near(mesh->get_normal(10)));
	ASSERT_TRUE(Vector3(0.356822f, 0.000000f, 0.934172f).is_near(mesh->get_normal(11)));
	ASSERT_TRUE(Vector3(-0.356822f, 0.000000f, 0.934172f).is_near(mesh->get_normal(12)));
	ASSERT_TRUE(Vector3(0.577350f, 0.577350f, -0.577350f).is_near(mesh->get_normal(13)));
	ASSERT_TRUE(Vector3(0.577350f, 0.577350f, 0.577350f).is_near(mesh->get_normal(14)));
	ASSERT_TRUE(Vector3(-0.577350f, 0.577350f, -0.577350f).is_near(mesh->get_normal(15)));
	ASSERT_TRUE(Vector3(-0.577350f, 0.577350f, 0.577350f).is_near(mesh->get_normal(16)));
	ASSERT_TRUE(Vector3(0.577350f, -0.577350f, -0.577350f).is_near(mesh->get_normal(17)));
	ASSERT_TRUE(Vector3(0.577350f, -0.577350f, 0.577350f).is_near(mesh->get_normal(18)));
	ASSERT_TRUE(Vector3(-0.577350f, -0.577350f, -0.577350f).is_near(mesh->get_normal(19)));
	ASSERT_TRUE(Vector3(-0.577350f, -0.577350f, 0.577350f).is_near(mesh->get_normal(20)));

	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_tex_coord(0)));

	ASSERT_EQ(2, mesh->get_face_vertex_position_index(0, 0));
	ASSERT_EQ(1, mesh->get_face_vertex_normal_index(0, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(0, 0));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(0, 0)));
	ASSERT_TRUE(Vector3(0.934172f, 0.356822f, 0.000000f).is_near(mesh->get_face_vertex_normal(0, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(0, 0)));
	ASSERT_EQ(3, mesh->get_face_vertex_position_index(0, 1));
	ASSERT_EQ(1, mesh->get_face_vertex_normal_index(0, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(0, 1));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(0, 1)));
	ASSERT_TRUE(Vector3(0.934172f, 0.356822f, 0.000000f).is_near(mesh->get_face_vertex_normal(0, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(0, 1)));
	ASSERT_EQ(7, mesh->get_face_vertex_position_index(0, 2));
	ASSERT_EQ(1, mesh->get_face_vertex_normal_index(0, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(0, 2));
	ASSERT_TRUE(Point3(0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(0, 2)));
	ASSERT_TRUE(Vector3(0.934172f, 0.356822f, 0.000000f).is_near(mesh->get_face_vertex_normal(0, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(0, 2)));
	ASSERT_EQ(2, mesh->get_face_vertex_position_index(1, 0));
	ASSERT_EQ(2, mesh->get_face_vertex_normal_index(1, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(1, 0));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(1, 0)));
	ASSERT_TRUE(Vector3(0.934172f, -0.356822f, 0.000000f).is_near(mesh->get_face_vertex_normal(1, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(1, 0)));
	ASSERT_EQ(8, mesh->get_face_vertex_position_index(1, 1));
	ASSERT_EQ(2, mesh->get_face_vertex_normal_index(1, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(1, 1));
	ASSERT_TRUE(Point3(0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(1, 1)));
	ASSERT_TRUE(Vector3(0.934172f, -0.356822f, 0.000000f).is_near(mesh->get_face_vertex_normal(1, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(1, 1)));
	ASSERT_EQ(3, mesh->get_face_vertex_position_index(1, 2));
	ASSERT_EQ(2, mesh->get_face_vertex_normal_index(1, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(1, 2));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(1, 2)));
	ASSERT_TRUE(Vector3(0.934172f, -0.356822f, 0.000000f).is_near(mesh->get_face_vertex_normal(1, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(1, 2)));
	ASSERT_EQ(4, mesh->get_face_vertex_position_index(2, 0));
	ASSERT_EQ(3, mesh->get_face_vertex_normal_index(2, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(2, 0));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(2, 0)));
	ASSERT_TRUE(Vector3(-0.934172f, 0.356822f, 0.000000f).is_near(mesh->get_face_vertex_normal(2, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(2, 0)));
	ASSERT_EQ(5, mesh->get_face_vertex_position_index(2, 1));
	ASSERT_EQ(3, mesh->get_face_vertex_normal_index(2, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(2, 1));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(2, 1)));
	ASSERT_TRUE(Vector3(-0.934172f, 0.356822f, 0.000000f).is_near(mesh->get_face_vertex_normal(2, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(2, 1)));
	ASSERT_EQ(6, mesh->get_face_vertex_position_index(2, 2));
	ASSERT_EQ(3, mesh->get_face_vertex_normal_index(2, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(2, 2));
	ASSERT_TRUE(Point3(-0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(2, 2)));
	ASSERT_TRUE(Vector3(-0.934172f, 0.356822f, 0.000000f).is_near(mesh->get_face_vertex_normal(2, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(2, 2)));
	ASSERT_EQ(5, mesh->get_face_vertex_position_index(3, 0));
	ASSERT_EQ(4, mesh->get_face_vertex_normal_index(3, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(3, 0));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(3, 0)));
	ASSERT_TRUE(Vector3(-0.934172f, -0.356822f, -0.000000f).is_near(mesh->get_face_vertex_normal(3, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(3, 0)));
	ASSERT_EQ(4, mesh->get_face_vertex_position_index(3, 1));
	ASSERT_EQ(4, mesh->get_face_vertex_normal_index(3, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(3, 1));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(3, 1)));
	ASSERT_TRUE(Vector3(-0.934172f, -0.356822f, -0.000000f).is_near(mesh->get_face_vertex_normal(3, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(3, 1)));
	ASSERT_EQ(9, mesh->get_face_vertex_position_index(3, 2));
	ASSERT_EQ(4, mesh->get_face_vertex_normal_index(3, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(3, 2));
	ASSERT_TRUE(Point3(-0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(3, 2)));
	ASSERT_TRUE(Vector3(-0.934172f, -0.356822f, -0.000000f).is_near(mesh->get_face_vertex_normal(3, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(3, 2)));
	ASSERT_EQ(7, mesh->get_face_vertex_position_index(4, 0));
	ASSERT_EQ(5, mesh->get_face_vertex_normal_index(4, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(4, 0));
	ASSERT_TRUE(Point3(0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(4, 0)));
	ASSERT_TRUE(Vector3(0.000000f, 0.934172f, 0.356822f).is_near(mesh->get_face_vertex_normal(4, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(4, 0)));
	ASSERT_EQ(6, mesh->get_face_vertex_position_index(4, 1));
	ASSERT_EQ(5, mesh->get_face_vertex_normal_index(4, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(4, 1));
	ASSERT_TRUE(Point3(-0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(4, 1)));
	ASSERT_TRUE(Vector3(0.000000f, 0.934172f, 0.356822f).is_near(mesh->get_face_vertex_normal(4, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(4, 1)));
	ASSERT_EQ(12, mesh->get_face_vertex_position_index(4, 2));
	ASSERT_EQ(5, mesh->get_face_vertex_normal_index(4, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(4, 2));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(4, 2)));
	ASSERT_TRUE(Vector3(0.000000f, 0.934172f, 0.356822f).is_near(mesh->get_face_vertex_normal(4, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(4, 2)));
	ASSERT_EQ(6, mesh->get_face_vertex_position_index(5, 0));
	ASSERT_EQ(6, mesh->get_face_vertex_normal_index(5, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(5, 0));
	ASSERT_TRUE(Point3(-0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(5, 0)));
	ASSERT_TRUE(Vector3(0.000000f, 0.934172f, -0.356822f).is_near(mesh->get_face_vertex_normal(5, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(5, 0)));
	ASSERT_EQ(7, mesh->get_face_vertex_position_index(5, 1));
	ASSERT_EQ(6, mesh->get_face_vertex_normal_index(5, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(5, 1));
	ASSERT_TRUE(Point3(0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(5, 1)));
	ASSERT_TRUE(Vector3(0.000000f, 0.934172f, -0.356822f).is_near(mesh->get_face_vertex_normal(5, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(5, 1)));
	ASSERT_EQ(11, mesh->get_face_vertex_position_index(5, 2));
	ASSERT_EQ(6, mesh->get_face_vertex_normal_index(5, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(5, 2));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(5, 2)));
	ASSERT_TRUE(Vector3(0.000000f, 0.934172f, -0.356822f).is_near(mesh->get_face_vertex_normal(5, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(5, 2)));
	ASSERT_EQ(10, mesh->get_face_vertex_position_index(6, 0));
	ASSERT_EQ(7, mesh->get_face_vertex_normal_index(6, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(6, 0));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(6, 0)));
	ASSERT_TRUE(Vector3(0.356822f, 0.000000f, -0.934172f).is_near(mesh->get_face_vertex_normal(6, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(6, 0)));
	ASSERT_EQ(11, mesh->get_face_vertex_position_index(6, 1));
	ASSERT_EQ(7, mesh->get_face_vertex_normal_index(6, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(6, 1));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(6, 1)));
	ASSERT_TRUE(Vector3(0.356822f, 0.000000f, -0.934172f).is_near(mesh->get_face_vertex_normal(6, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(6, 1)));
	ASSERT_EQ(3, mesh->get_face_vertex_position_index(6, 2));
	ASSERT_EQ(7, mesh->get_face_vertex_normal_index(6, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(6, 2));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(6, 2)));
	ASSERT_TRUE(Vector3(0.356822f, 0.000000f, -0.934172f).is_near(mesh->get_face_vertex_normal(6, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(6, 2)));
	ASSERT_EQ(11, mesh->get_face_vertex_position_index(7, 0));
	ASSERT_EQ(8, mesh->get_face_vertex_normal_index(7, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(7, 0));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(7, 0)));
	ASSERT_TRUE(Vector3(-0.356822f, -0.000000f, -0.934172f).is_near(mesh->get_face_vertex_normal(7, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(7, 0)));
	ASSERT_EQ(10, mesh->get_face_vertex_position_index(7, 1));
	ASSERT_EQ(8, mesh->get_face_vertex_normal_index(7, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(7, 1));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(7, 1)));
	ASSERT_TRUE(Vector3(-0.356822f, -0.000000f, -0.934172f).is_near(mesh->get_face_vertex_normal(7, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(7, 1)));
	ASSERT_EQ(4, mesh->get_face_vertex_position_index(7, 2));
	ASSERT_EQ(8, mesh->get_face_vertex_normal_index(7, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(7, 2));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(7, 2)));
	ASSERT_TRUE(Vector3(-0.356822f, -0.000000f, -0.934172f).is_near(mesh->get_face_vertex_normal(7, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(7, 2)));
	ASSERT_EQ(8, mesh->get_face_vertex_position_index(8, 0));
	ASSERT_EQ(9, mesh->get_face_vertex_normal_index(8, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(8, 0));
	ASSERT_TRUE(Point3(0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(8, 0)));
	ASSERT_TRUE(Vector3(-0.000000f, -0.934172f, -0.356822f).is_near(mesh->get_face_vertex_normal(8, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(8, 0)));
	ASSERT_EQ(9, mesh->get_face_vertex_position_index(8, 1));
	ASSERT_EQ(9, mesh->get_face_vertex_normal_index(8, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(8, 1));
	ASSERT_TRUE(Point3(-0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(8, 1)));
	ASSERT_TRUE(Vector3(-0.000000f, -0.934172f, -0.356822f).is_near(mesh->get_face_vertex_normal(8, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(8, 1)));
	ASSERT_EQ(10, mesh->get_face_vertex_position_index(8, 2));
	ASSERT_EQ(9, mesh->get_face_vertex_normal_index(8, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(8, 2));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(8, 2)));
	ASSERT_TRUE(Vector3(-0.000000f, -0.934172f, -0.356822f).is_near(mesh->get_face_vertex_normal(8, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(8, 2)));
	ASSERT_EQ(9, mesh->get_face_vertex_position_index(9, 0));
	ASSERT_EQ(10, mesh->get_face_vertex_normal_index(9, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(9, 0));
	ASSERT_TRUE(Point3(-0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(9, 0)));
	ASSERT_TRUE(Vector3(0.000000f, -0.934172f, 0.356822f).is_near(mesh->get_face_vertex_normal(9, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(9, 0)));
	ASSERT_EQ(8, mesh->get_face_vertex_position_index(9, 1));
	ASSERT_EQ(10, mesh->get_face_vertex_normal_index(9, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(9, 1));
	ASSERT_TRUE(Point3(0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(9, 1)));
	ASSERT_TRUE(Vector3(0.000000f, -0.934172f, 0.356822f).is_near(mesh->get_face_vertex_normal(9, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(9, 1)));
	ASSERT_EQ(1, mesh->get_face_vertex_position_index(9, 2));
	ASSERT_EQ(10, mesh->get_face_vertex_normal_index(9, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(9, 2));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(9, 2)));
	ASSERT_TRUE(Vector3(0.000000f, -0.934172f, 0.356822f).is_near(mesh->get_face_vertex_normal(9, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(9, 2)));
	ASSERT_EQ(12, mesh->get_face_vertex_position_index(10, 0));
	ASSERT_EQ(11, mesh->get_face_vertex_normal_index(10, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(10, 0));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(10, 0)));
	ASSERT_TRUE(Vector3(0.356822f, 0.000000f, 0.934172f).is_near(mesh->get_face_vertex_normal(10, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(10, 0)));
	ASSERT_EQ(1, mesh->get_face_vertex_position_index(10, 1));
	ASSERT_EQ(11, mesh->get_face_vertex_normal_index(10, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(10, 1));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(10, 1)));
	ASSERT_TRUE(Vector3(0.356822f, 0.000000f, 0.934172f).is_near(mesh->get_face_vertex_normal(10, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(10, 1)));
	ASSERT_EQ(2, mesh->get_face_vertex_position_index(10, 2));
	ASSERT_EQ(11, mesh->get_face_vertex_normal_index(10, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(10, 2));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(10, 2)));
	ASSERT_TRUE(Vector3(0.356822f, 0.000000f, 0.934172f).is_near(mesh->get_face_vertex_normal(10, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(10, 2)));
	ASSERT_EQ(1, mesh->get_face_vertex_position_index(11, 0));
	ASSERT_EQ(12, mesh->get_face_vertex_normal_index(11, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(11, 0));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(11, 0)));
	ASSERT_TRUE(Vector3(-0.356822f, 0.000000f, 0.934172f).is_near(mesh->get_face_vertex_normal(11, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(11, 0)));
	ASSERT_EQ(12, mesh->get_face_vertex_position_index(11, 1));
	ASSERT_EQ(12, mesh->get_face_vertex_normal_index(11, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(11, 1));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(11, 1)));
	ASSERT_TRUE(Vector3(-0.356822f, 0.000000f, 0.934172f).is_near(mesh->get_face_vertex_normal(11, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(11, 1)));
	ASSERT_EQ(5, mesh->get_face_vertex_position_index(11, 2));
	ASSERT_EQ(12, mesh->get_face_vertex_normal_index(11, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(11, 2));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(11, 2)));
	ASSERT_TRUE(Vector3(-0.356822f, 0.000000f, 0.934172f).is_near(mesh->get_face_vertex_normal(11, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(11, 2)));
	ASSERT_EQ(7, mesh->get_face_vertex_position_index(12, 0));
	ASSERT_EQ(13, mesh->get_face_vertex_normal_index(12, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(12, 0));
	ASSERT_TRUE(Point3(0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(12, 0)));
	ASSERT_TRUE(Vector3(0.577350f, 0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(12, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(12, 0)));
	ASSERT_EQ(3, mesh->get_face_vertex_position_index(12, 1));
	ASSERT_EQ(13, mesh->get_face_vertex_normal_index(12, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(12, 1));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(12, 1)));
	ASSERT_TRUE(Vector3(0.577350f, 0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(12, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(12, 1)));
	ASSERT_EQ(11, mesh->get_face_vertex_position_index(12, 2));
	ASSERT_EQ(13, mesh->get_face_vertex_normal_index(12, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(12, 2));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(12, 2)));
	ASSERT_TRUE(Vector3(0.577350f, 0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(12, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(12, 2)));
	ASSERT_EQ(2, mesh->get_face_vertex_position_index(13, 0));
	ASSERT_EQ(14, mesh->get_face_vertex_normal_index(13, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(13, 0));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(13, 0)));
	ASSERT_TRUE(Vector3(0.577350f, 0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(13, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(13, 0)));
	ASSERT_EQ(7, mesh->get_face_vertex_position_index(13, 1));
	ASSERT_EQ(14, mesh->get_face_vertex_normal_index(13, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(13, 1));
	ASSERT_TRUE(Point3(0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(13, 1)));
	ASSERT_TRUE(Vector3(0.577350f, 0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(13, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(13, 1)));
	ASSERT_EQ(12, mesh->get_face_vertex_position_index(13, 2));
	ASSERT_EQ(14, mesh->get_face_vertex_normal_index(13, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(13, 2));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(13, 2)));
	ASSERT_TRUE(Vector3(0.577350f, 0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(13, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(13, 2)));
	ASSERT_EQ(4, mesh->get_face_vertex_position_index(14, 0));
	ASSERT_EQ(15, mesh->get_face_vertex_normal_index(14, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(14, 0));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(14, 0)));
	ASSERT_TRUE(Vector3(-0.577350f, 0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(14, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(14, 0)));
	ASSERT_EQ(6, mesh->get_face_vertex_position_index(14, 1));
	ASSERT_EQ(15, mesh->get_face_vertex_normal_index(14, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(14, 1));
	ASSERT_TRUE(Point3(-0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(14, 1)));
	ASSERT_TRUE(Vector3(-0.577350f, 0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(14, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(14, 1)));
	ASSERT_EQ(11, mesh->get_face_vertex_position_index(14, 2));
	ASSERT_EQ(15, mesh->get_face_vertex_normal_index(14, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(14, 2));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(14, 2)));
	ASSERT_TRUE(Vector3(-0.577350f, 0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(14, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(14, 2)));
	ASSERT_EQ(6, mesh->get_face_vertex_position_index(15, 0));
	ASSERT_EQ(16, mesh->get_face_vertex_normal_index(15, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(15, 0));
	ASSERT_TRUE(Point3(-0.525731f, 0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(15, 0)));
	ASSERT_TRUE(Vector3(-0.577350f, 0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(15, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(15, 0)));
	ASSERT_EQ(5, mesh->get_face_vertex_position_index(15, 1));
	ASSERT_EQ(16, mesh->get_face_vertex_normal_index(15, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(15, 1));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(15, 1)));
	ASSERT_TRUE(Vector3(-0.577350f, 0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(15, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(15, 1)));
	ASSERT_EQ(12, mesh->get_face_vertex_position_index(15, 2));
	ASSERT_EQ(16, mesh->get_face_vertex_normal_index(15, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(15, 2));
	ASSERT_TRUE(Point3(0.000000f, 0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(15, 2)));
	ASSERT_TRUE(Vector3(-0.577350f, 0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(15, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(15, 2)));
	ASSERT_EQ(3, mesh->get_face_vertex_position_index(16, 0));
	ASSERT_EQ(17, mesh->get_face_vertex_normal_index(16, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(16, 0));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(16, 0)));
	ASSERT_TRUE(Vector3(0.577350f, -0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(16, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(16, 0)));
	ASSERT_EQ(8, mesh->get_face_vertex_position_index(16, 1));
	ASSERT_EQ(17, mesh->get_face_vertex_normal_index(16, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(16, 1));
	ASSERT_TRUE(Point3(0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(16, 1)));
	ASSERT_TRUE(Vector3(0.577350f, -0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(16, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(16, 1)));
	ASSERT_EQ(10, mesh->get_face_vertex_position_index(16, 2));
	ASSERT_EQ(17, mesh->get_face_vertex_normal_index(16, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(16, 2));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(16, 2)));
	ASSERT_TRUE(Vector3(0.577350f, -0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(16, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(16, 2)));
	ASSERT_EQ(8, mesh->get_face_vertex_position_index(17, 0));
	ASSERT_EQ(18, mesh->get_face_vertex_normal_index(17, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(17, 0));
	ASSERT_TRUE(Point3(0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(17, 0)));
	ASSERT_TRUE(Vector3(0.577350f, -0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(17, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(17, 0)));
	ASSERT_EQ(2, mesh->get_face_vertex_position_index(17, 1));
	ASSERT_EQ(18, mesh->get_face_vertex_normal_index(17, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(17, 1));
	ASSERT_TRUE(Point3(0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(17, 1)));
	ASSERT_TRUE(Vector3(0.577350f, -0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(17, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(17, 1)));
	ASSERT_EQ(1, mesh->get_face_vertex_position_index(17, 2));
	ASSERT_EQ(18, mesh->get_face_vertex_normal_index(17, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(17, 2));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(17, 2)));
	ASSERT_TRUE(Vector3(0.577350f, -0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(17, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(17, 2)));
	ASSERT_EQ(4, mesh->get_face_vertex_position_index(18, 0));
	ASSERT_EQ(19, mesh->get_face_vertex_normal_index(18, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(18, 0));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, -0.525731f).is_near(mesh->get_face_vertex_position(18, 0)));
	ASSERT_TRUE(Vector3(-0.577350f, -0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(18, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(18, 0)));
	ASSERT_EQ(10, mesh->get_face_vertex_position_index(18, 1));
	ASSERT_EQ(19, mesh->get_face_vertex_normal_index(18, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(18, 1));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, -0.850651f).is_near(mesh->get_face_vertex_position(18, 1)));
	ASSERT_TRUE(Vector3(-0.577350f, -0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(18, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(18, 1)));
	ASSERT_EQ(9, mesh->get_face_vertex_position_index(18, 2));
	ASSERT_EQ(19, mesh->get_face_vertex_normal_index(18, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(18, 2));
	ASSERT_TRUE(Point3(-0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(18, 2)));
	ASSERT_TRUE(Vector3(-0.577350f, -0.577350f, -0.577350f).is_near(mesh->get_face_vertex_normal(18, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(18, 2)));
	ASSERT_EQ(5, mesh->get_face_vertex_position_index(19, 0));
	ASSERT_EQ(20, mesh->get_face_vertex_normal_index(19, 0));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(19, 0));
	ASSERT_TRUE(Point3(-0.850651f, 0.000000f, 0.525731f).is_near(mesh->get_face_vertex_position(19, 0)));
	ASSERT_TRUE(Vector3(-0.577350f, -0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(19, 0)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(19, 0)));
	ASSERT_EQ(9, mesh->get_face_vertex_position_index(19, 1));
	ASSERT_EQ(20, mesh->get_face_vertex_normal_index(19, 1));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(19, 1));
	ASSERT_TRUE(Point3(-0.525731f, -0.850651f, 0.000000f).is_near(mesh->get_face_vertex_position(19, 1)));
	ASSERT_TRUE(Vector3(-0.577350f, -0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(19, 1)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(19, 1)));
	ASSERT_EQ(1, mesh->get_face_vertex_position_index(19, 2));
	ASSERT_EQ(20, mesh->get_face_vertex_normal_index(19, 2));
	ASSERT_EQ(0, mesh->get_face_vertex_tex_coord_index(19, 2));
	ASSERT_TRUE(Point3(0.000000f, -0.525731f, 0.850651f).is_near(mesh->get_face_vertex_position(19, 2)));
	ASSERT_TRUE(Vector3(-0.577350f, -0.577350f, 0.577350f).is_near(mesh->get_face_vertex_normal(19, 2)));
	ASSERT_TRUE(Uv(0.000000f, 0.000000f).is_near(mesh->get_face_vertex_tex_coord(19, 2)));
}

int main(int argc, char **argv)
{
	testing::InitGoogleTest(&argc, argv);
	return RUN_ALL_TESTS();
}